require "defines"

events = defines.events
events.portal_opened = script.generate_event_name()
events.on_close_button_click = script.generate_event_name()
events.on_portal_chosen = script.generate_event_name()

script.on_init(function()
	if global.portals == nil then	
		global.portals = {}
	end
	
	
end)

script.on_event(events.on_built_entity, function(event)
	if(event.created_entity.name == "portal") then
		n = 0
		for i, p in pairs(global.portals) do
			n = n + 1
		end
		global.portals[n + 1] = event.created_entity
	end
end)

script.on_event(events.on_tick, function(event)
	for i, p in pairs(global.portals) do
		if not p.valid then
			table.remove(global.portals, i)
		end
	end

	if (game.player.gui.top["invisible-screen"] == nil) and (game.player.selected ~= nil) then
		if game.player.selected.name == "portal" then
			game.player.gui.top.add{type = "flow", name = "invisible-screen", direction = "horizontal"}
			game.player.gui.top["invisible-screen"].style.minimal_width = 1000
			game.player.gui.top["invisible-screen"].style.minimal_height = 1000
		end
	end
	if game.player.selected == nil and game.player.gui.top["invisible-screen"] ~= nil then
		game.player.gui.top["invisible-screen"].destroy()
		game.player.clear_selected_entity()
	end
end)


function is_portal(entity)
    return entity.name == 'portal'
end

script.on_event(events.on_gui_click, function(event)
	if event.element.name == "close-button" then
		game.raise_event(events.on_close_button_click, {entity = event.element})
		return
	end
	
	if(event.element.name == "invisible-screen") then
		if game.player.selected ~= nil then
			if game.player.selected.name == "portal" then
				game.raise_event(events.portal_opened, {entity = game.player.selected})
			end
		end
		return
	end
	
	
	if (string.find(event.element.name, "portal%-label") ~= nil) then
		game.raise_event(events.on_portal_chosen, {entity = event.element})
		return
	end
end)

script.on_event(events.on_close_button_click, function(event)
	event.entity.parent.destroy()
end)

script.on_event(events.on_portal_chosen, function(event)
	if not (event.entity.valid) then
		return
	end
	name = event.entity.name
	game.player.print(name)
	i, j = string.find(name, "portal%-label")
	name = string.sub(name, j + 1)
	i, j = string.find(name, "a")
	strX = string.sub(name, 1, i - 1)
	posX = tonumber(strX)
	strY = string.sub(name, i+1)
	posY = tonumber(strY)
	
	game.player.character.teleport({ x = posX + 1, y = posY + 1})
	
	event.entity.parent.parent.destroy()
end)

script.on_event(events.portal_opened, function(event)
	for k, child in pairs(game.player.gui.center.children_names) do
		game.player.gui.center[child].destroy()
	end
	
	game.player.gui.center.add{type = "flow", name = "portal-window", direction = "horizontal"}
	local portal_window = game.player.gui.center["portal-window"]
	
	portal_window.add{type = "frame", name = "available-portals", direction = "vertical"}
	local available_portals = portal_window["available-portals"]
	available_portals.style.minimal_width = 500
	available_portals.style.maximal_width = 500
	
	for id, portal in pairs(global.portals)
		-- pairs(game.get_surface(1).find_entities_filtered{
		-- area = {{game.player.position.x - 10000, game.player.position.y - 10000}, {game.player.position.x + 10000, game.player.position.y + 10000}}, 
		-- name = "portal",
		-- })
	do
		if available_portals["portal-label" .. portal.position.x .. "a" .. portal.position.y] == nil then
			available_portals.add{
				type = "label", 
				name = "portal-label" .. portal.position.x .. "a" .. portal.position.y,
				caption = "Portal at position {" .. portal.position.x .. ", " .. portal.position.y .. "}",
			}
			available_portals["portal-label" .. portal.position.x .. "a" .. portal.position.y].style.minimal_width = 500
			available_portals["portal-label" .. portal.position.x .. "a" .. portal.position.y].style.maximal_width = 500
		end
	end
	
	portal_window.add{type = "button", name = "close-button", caption = "X"}
	portal_window["close-button"].style.minimal_width = 10
	portal_window["close-button"].style.minimal_height = 10
	
end)

-- create an interface for other mods to access raised event.
remote.add_interface("machine_opened", {
	event = function()
		return events.machine_opened
	end
})
